module Pics1 where
import BitmapOps(bm)
import InvaderTypes

bmScale = 1 :: Int

pics obj =
  case obj of
    Base       -> base1
    Explode    -> explode1
    Ufo        -> spacer1
    VShot A    -> sperma1
    VShot B    -> spermb1
    Vader R1 A -> vader1a1
    Vader R1 B -> vader1b1
    Vader R2 A -> vader2a1
    Vader R2 B -> vader2b1
    Vader R3 A -> vader3a1
    Vader R3 B -> vader3b1
    VExplode _ -> vexplode1

{-
Copyright notice:

This is mine.  I'm only letting you use it.  Period.  Feel free to rip off
any of the code you see fit, but have the courtesy to give me credit.
Otherwise great hairy beasties will rip your eyes out and eat your flesh
when you least expect it.

Jonny Goldman <jonathan@think.com>

Wed May  8 1991
-}

--pics1 = [base1,explode1,spacer1,sperma1,spermb1,
--         vader1a1,vader1b1,vader2a1,vader2b1,vader3a1,vader3b1,vexplode1]

base1 = bm 15 10 base1_bits
base1_bits = [
   0x80, 0x00, 0xc0, 0x01, 0xc0, 0x01, 0xe0, 0x03, 0xfe, 0x3f, 0xff, 0x7f,
   0xff, 0x7f, 0xff, 0x7f, 0xff, 0x7f, 0xff, 0x7f]

explode1 = bm 15 10 explode1_bits
explode1_bits = [
   0x80, 0x00, 0xc0, 0x01, 0xc0, 0x01, 0x20, 0x02, 0x3e, 0x3e, 0x0d, 0x50,
   0x15, 0x48, 0x6d, 0x5b, 0x65, 0x4b, 0xff, 0x7f]

spacer1 = bm 16 8 spacer1_bits
spacer1_bits = [
   0xc0, 0x03, 0xf0, 0x0f, 0xf8, 0x1f, 0xfc, 0x3f, 0xb6, 0x6d, 0xff, 0xff,
   0x1c, 0x38, 0x08, 0x10]

sperma1 = bm 3 7 sperma1_bits
sperma1_bits = [0x02, 0x01, 0x02, 0x04, 0x02, 0x01, 0x02]

spermb1 = bm 3 7 spermb1_bits
spermb1_bits = [0x02, 0x04, 0x02, 0x01, 0x02, 0x04, 0x02]

vader1a1 = bm 10 8 vader1a1_bits
vader1a1_bits = [
   0x30, 0x00, 0x78, 0x00, 0xfc, 0x00, 0xb6, 0x01, 0xfe, 0x01, 0xb4, 0x00,
   0x02, 0x01, 0x84, 0x00]

vader1b1 = bm 10 8 vader1b1_bits
vader1b1_bits = [
   0x30, 0x00, 0x78, 0x00, 0xfc, 0x00, 0xb6, 0x01, 0xfe, 0x01, 0xb4, 0x00,
   0x48, 0x00, 0x84, 0x00]

vader2a1 = bm 12 8 vader2a1_bits
vader2a1_bits = [
   0x08, 0x01, 0x90, 0x00, 0xf8, 0x01, 0x6c, 0x03, 0xfe, 0x07, 0xfa, 0x05,
   0x0a, 0x05, 0x90, 0x00]

vader2b1 = bm 12 8 vader2b1_bits
vader2b1_bits = [
   0x08, 0x01, 0x92, 0x04, 0xfa, 0x05, 0x6e, 0x07, 0xfc, 0x03, 0xf8, 0x01,
   0x08, 0x01, 0x04, 0x02]

vader3a1 = bm 14 8 vader3a1_bits
vader3a1_bits = [
   0xe0, 0x01, 0xfc, 0x0f, 0xfe, 0x1f, 0xce, 0x1c, 0xfe, 0x1f, 0x38, 0x07,
   0xcc, 0x0c, 0x18, 0x06]

vader3b1 = bm 14 8 vader3b1_bits
vader3b1_bits = [
   0xe0, 0x01, 0xfc, 0x0f, 0xfe, 0x1f, 0xce, 0x1c, 0xfe, 0x1f, 0x38, 0x07,
   0xcc, 0x0c, 0x06, 0x18]

vexplode1 = bm 14 8 vexplode1_bits
vexplode1_bits = [
   0x48, 0x04, 0x50, 0x02, 0x00, 0x00, 0x06, 0x18, 0x10, 0x02, 0x88, 0x04,
   0x80, 0x00, 0x00, 0x00]

